using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.IO.Compression;
using System.Windows.Forms;

namespace Unzipping
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnBrowse_Click(object sender, EventArgs e)
        {
            // Show the dialog where the user chooses the file to decompress 
            if (openFile.ShowDialog() == DialogResult.OK)
            {
                txtPath.Text = openFile.FileName;
            }
        }

        private void btnDecompress_Click(object sender, EventArgs e)
        {
            // If the user has selected a path where to put the decompressed file
            if (saveFile.ShowDialog() == DialogResult.OK)
            {
                // Bytes array in which we're going to store the actual file to be decompressed
                byte[] bufferWrite;
                // Will open the file to be decompressed
                FileStream fsSource;
                // Will write the new decompressed file
                FileStream fsDest;
                // To hold the compressed file
                GZipStream gzDecompressed;
                fsSource = new FileStream(txtPath.Text, FileMode.Open, FileAccess.Read, FileShare.Read);
                // Will hold the compressed stream created from the destination stream
                gzDecompressed = new GZipStream(fsSource, CompressionMode.Decompress, true);

                // Retrieve the size of the file from the compressed archive's footer
                bufferWrite = new byte[4];
                fsSource.Position = (int)fsSource.Length - 4;
                // Write the first 4 bytes of data from the compressed file into the buffer
                fsSource.Read(bufferWrite, 0, 4);
                // Set the position back at the start
                fsSource.Position = 0;
                int bufferLength = BitConverter.ToInt32(bufferWrite, 0);

                byte[] buffer = new byte[bufferLength + 100];
                int readOffset = 0;
                int totalBytes = 0;

                // Loop through the compressed stream and put it into the buffer
                while (true)
                {
                    int bytesRead = gzDecompressed.Read(buffer, readOffset, 100);
                    
                    // If we reached the end of the data
                    if (bytesRead == 0)
                        break;

                    readOffset += bytesRead;
                    totalBytes += bytesRead;
                }

                // Write the content of the buffer to the destination stream (file)
                fsDest = new FileStream(saveFile.FileName, FileMode.Create);
                fsDest.Write(buffer, 0, totalBytes);

                // Close the streams
                fsSource.Close();
                gzDecompressed.Close();
                fsDest.Close();
            }
        }
    }
}